# Retrieve Objects

## Functions

HWLOC_DECLSPEC hwloc_obj_t | hwloc_get_obj_by_depth (hwloc_topology_t topology, unsigned depth, unsigned idx) __hwloc_attribute_pure
| Returns the topology object at index `index` from depth `depth`.
static __hwloc_inline hwloc_obj_t __hwloc_attribute_pure | hwloc_get_obj_by_type (hwloc_topology_t topology, hwloc_obj_type_t type, unsigned idx)
| Returns the topology object at index `index` with type `type`.

## Function Documentation

HWLOC_DECLSPEC hwloc_obj_t hwloc_get_obj_by_depth | ( | hwloc_topology_t | topology,
|  | unsigned | depth,
|  | unsigned | idx |
| ) |  |  |

Returns the topology object at index `index` from depth `depth`.

static __hwloc_inline hwloc_obj_t __hwloc_attribute_pure hwloc_get_obj_by_type | ( | hwloc_topology_t | topology,
|  | hwloc_obj_type_t | type,
|  | unsigned | idx |
| ) |  |  | `[static]`

Returns the topology object at index `index` with type `type`.

If no object for that type exists, `NULL` is returned. If there are several levels with objects of that type, `NULL` is returned and ther caller may fallback to hwloc_get_obj_by_depth().